/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.TiporepeticaoRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Tiporepeticao extends TableImpl<TiporepeticaoRecord> {

    private static final long serialVersionUID = 315358004;

    /**
     * The reference instance of <code>public.tiporepeticao</code>
     */
    public static final Tiporepeticao TIPOREPETICAO = new Tiporepeticao();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TiporepeticaoRecord> getRecordType() {
        return TiporepeticaoRecord.class;
    }

    /**
     * The column <code>public.tiporepeticao.tiprepid</code>.
     */
    public final TableField<TiporepeticaoRecord, Integer> TIPREPID = createField("tiprepid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('tiporepeticao_tiprepid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.tiporepeticao.tiprepnome</code>.
     */
    public final TableField<TiporepeticaoRecord, String> TIPREPNOME = createField("tiprepnome", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.tiporepeticao.tiprepdescricao</code>.
     */
    public final TableField<TiporepeticaoRecord, String> TIPREPDESCRICAO = createField("tiprepdescricao", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * Create a <code>public.tiporepeticao</code> table reference
     */
    public Tiporepeticao() {
        this(DSL.name("tiporepeticao"), null);
    }

    /**
     * Create an aliased <code>public.tiporepeticao</code> table reference
     */
    public Tiporepeticao(String alias) {
        this(DSL.name(alias), TIPOREPETICAO);
    }

    /**
     * Create an aliased <code>public.tiporepeticao</code> table reference
     */
    public Tiporepeticao(Name alias) {
        this(alias, TIPOREPETICAO);
    }

    private Tiporepeticao(Name alias, Table<TiporepeticaoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Tiporepeticao(Name alias, Table<TiporepeticaoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.TIPOREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<TiporepeticaoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_TIPOREPETICAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<TiporepeticaoRecord> getPrimaryKey() {
        return Keys.TIPOREPETICAO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<TiporepeticaoRecord>> getKeys() {
        return Arrays.<UniqueKey<TiporepeticaoRecord>>asList(Keys.TIPOREPETICAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Tiporepeticao as(String alias) {
        return new Tiporepeticao(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Tiporepeticao as(Name alias) {
        return new Tiporepeticao(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Tiporepeticao rename(String name) {
        return new Tiporepeticao(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Tiporepeticao rename(Name name) {
        return new Tiporepeticao(name, null);
    }
}
